import requests
from flask_login import AnonymousUserMixin

from webapp import models

class AnonymousUser(AnonymousUserMixin):
    def is_admin(self):
        return False

class User(object):
    def __init__(self, username):
        self.username = username.lower().strip()
        self._admin = None

    def is_authenticated(self):
        return True

    def is_active(self):
        return True

    def is_anonymous(self):
        return False

    def get_id(self):
        return self.username

    def is_admin(self):
        if not self.is_authenticated():
            return False
        if self._admin is None:
            req = requests.get(
                'https://capacifier.hackerspace.pl/kasownik_access/%s'
                % self.username)
            self._admin = req.status_code == 200
        return self._admin

    def get_model(self, deep=True):
        return models.Member.get_members(deep) \
            .filter_by(username=self.username).first()
